import "typings-test";
import "should";
import * as smartnginx from "../dist/index";

describe("smartnginx",function(){
    let testNginxConfig:smartnginx.NginxConfig;
    let testNginxZone01:smartnginx.NginxZone;
    let testNginxZone02:smartnginx.NginxZone;
    describe("NginxZone",function(){
        it(`"new NginxZone()" should produce an instance of NginxConfig`,function(){
            testNginxZone01 = new smartnginx.NginxZone({
                zoneName:"test1.bleu.de",
                type:smartnginx.zoneTypes.reverseProxy,
                destination:"192.192.192.192"
            });
            testNginxZone01.should.be.instanceof(smartnginx.NginxZone);
            console.log(testNginxZone01.configString);
        });
    });
    describe("NginxConfig",function(){
        it(`"new NginxConfig()" should produce an instance of NginxConfig`,function(){
            testNginxConfig = new smartnginx.NginxConfig();
            testNginxConfig.should.be.instanceof(smartnginx.NginxConfig);
        });
        describe(".addZone()",function(){
            it("should add a zone to NginxConfig Object",function(){
                testNginxConfig.addZone(testNginxZone01);
            })
        });
        describe(".deploy()",function(){
            it("should deploy a config from an instance",function(){
                testNginxConfig.deploy();
            })
        });
    });
});
